<?php
// Register Custom Post Type
function hr_office_vacancy_custom_post_type() {

  $labels = array(
    'name'                  => _x( 'HROffice Vacancy Shortcode', 'Post Type General Name', 'hr_office_vacancy_domain' ),
    'singular_name'         => _x( 'HROffice Vacancy Shortcode', 'Post Type Singular Name', 'hr_office_vacancy_domain' ),
    'menu_name'             => __( 'HROffice Vacancy', 'hr_office_vacancy_domain' ),
    'name_admin_bar'        => __( 'HROffice Vacancy Shortcode', 'hr_office_vacancy_domain' ),
    'archives'              => __( 'Item Archives', 'hr_office_vacancy_domain' ),
    'attributes'            => __( 'Item Attributes', 'hr_office_vacancy_domain' ),
    'parent_item_colon'     => __( 'Parent Item:', 'hr_office_vacancy_domain' ),
    'all_items'             => __( 'All Shortcodes', 'hr_office_vacancy_domain' ),
    'add_new_item'          => __( 'Add New Shortcode', 'hr_office_vacancy_domain' ),
    'add_new'               => __( 'Add New', 'hr_office_vacancy_domain' ),
    'new_item'              => __( 'New Item', 'hr_office_vacancy_domain' ),
    'edit_item'             => __( 'Edit Shortcode', 'hr_office_vacancy_domain' ),
    'update_item'           => __( 'Update Item', 'hr_office_vacancy_domain' ),
    'view_item'             => __( 'View Item', 'hr_office_vacancy_domain' ),
    'view_items'            => __( 'View Items', 'hr_office_vacancy_domain' ),
    'search_items'          => __( 'Search Item', 'hr_office_vacancy_domain' ),
    'not_found'             => __( 'Not found', 'hr_office_vacancy_domain' ),
    'not_found_in_trash'    => __( 'Not found in Trash', 'hr_office_vacancy_domain' ),
    'featured_image'        => __( 'Featured Image', 'hr_office_vacancy_domain' ),
    'set_featured_image'    => __( 'Set featured image', 'hr_office_vacancy_domain' ),
    'remove_featured_image' => __( 'Remove featured image', 'hr_office_vacancy_domain' ),
    'use_featured_image'    => __( 'Use as featured image', 'hr_office_vacancy_domain' ),
    'insert_into_item'      => __( 'Insert into item', 'hr_office_vacancy_domain' ),
    'uploaded_to_this_item' => __( 'Uploaded to this item', 'hr_office_vacancy_domain' ),
    'items_list'            => __( 'Items list', 'hr_office_vacancy_domain' ),
    'items_list_navigation' => __( 'Items list navigation', 'hr_office_vacancy_domain' ),
    'filter_items_list'     => __( 'Filter items list', 'hr_office_vacancy_domain' ),
  );
  $args = array(
    'label'                 => __( 'HROffice Vacancy Shortcode', 'hr_office_vacancy_domain' ),
    'description'           => __( 'hr office vacancy shortcode', 'hr_office_vacancy_domain' ),
    'labels'                => $labels,
    'supports'              => array( 'title'),
    'hierarchical'          => false,
    'public'                => false,
    'show_ui'               => true,
    'show_in_menu'          => true,
    'menu_position'         => 5,
    'show_in_admin_bar'     => false,
    'show_in_nav_menus'     => false,
    'can_export'            => true,
    'has_archive'           => false,
    'exclude_from_search'   => true,
    'publicly_queryable'    => true,
    'rewrite'               => false,
    'capability_type'       => 'page',
  );
  register_post_type( 'hroffice_vacn_shortc', $args );

}
add_action( 'init', 'hr_office_vacancy_custom_post_type');

// Add Shortcode Column
function hr_office_vacancy_post_add_columns($columns) {    
    $columns['api_shortcode']  = __('Shortcode');
    return $columns;
}
add_filter('manage_hroffice_vacn_shortc_posts_columns' , 'hr_office_vacancy_post_add_columns');

function hr_office_vacancy_post_add_columns_content( $column_name, $post_id ) {
    if( $column_name == 'api_shortcode' ) {
        $featured_product = get_post_meta( $post_id, '_api_language_id', true );
        if(get_post_meta( $post_id, '_api_connected_first_job_id', true ) != 0){
          echo '[hroffice-vacancy id="'.$post_id.'"]';  
        }else{
          echo '';
        }
        
    }
}
add_action( 'manage_hroffice_vacn_shortc_posts_custom_column', 'hr_office_vacancy_post_add_columns_content', 10, 2 );

// Remove View link 
function hr_office_vacancy_post_row_view_actions($actions)
{
    if( get_post_type() === 'hroffice_vacn_shortc' )
    {
        unset( $actions['view'] );
        unset( $actions['inline hide-if-no-js'] );
    }
    return $actions;
}
add_filter( 'post_row_actions', 'hr_office_vacancy_post_row_view_actions', 10, 1 );

// Post Updated Messages
function hr_office_vacancy_post_type_messages($messages) {
  global $post, $post_ID;

  $post_type = get_post_type( $post_ID );
  $obj = get_post_type_object($post_type);

  $singular = $obj->labels->singular_name;

  $viewLink = ($obj->public) ?  ' <a href="%s">View '.strtolower($singular).'</a>' : "";
  $previewLink = ($obj->public) ? ' <a target="_blank" href="%s">Preview '.strtolower($singular).'</a>': "";
  $schedPreviewLink = ($obj->public) ? ' <a target="_blank" href="%2$s">Preview '.strtolower($singular).'</a>': "";

  $messages['hroffice_vacn_shortc'] = array(
    0 => '', // Unused. Messages start at index 1.
    1 => sprintf( __($singular.' updated.'.$viewLink), esc_url( get_permalink($post_ID) ) ),
    2 => __('Custom field updated.'),
    3 => __('Custom field deleted.'),
    4 => __($singular.' updated.'),
    5 => isset($_GET['revision']) ? sprintf( __($singular.' restored to revision from %s'), wp_post_revision_title( (int) $_GET['revision'], false ) ) : false,
    6 => sprintf( __($singular.' published.'.$viewLink), esc_url( get_permalink($post_ID) ) ),
    7 => __('Page saved.'),
    8 => sprintf( __($singular.' submitted.'.$previewLink), esc_url( add_query_arg( 'preview', 'true', get_permalink($post_ID) ) ) ),
    9 => sprintf( __($singular.' scheduled for: <strong>%1$s</strong>.'.$schedPreviewLink), date_i18n( __( 'M j, Y @ G:i' ), strtotime( $post->post_date ) ), esc_url( get_permalink($post_ID) ) ),
    10 => sprintf( __($singular.' draft updated.'.$previewLink), esc_url( add_query_arg( 'preview', 'true', get_permalink($post_ID) ) ) ),
  );
  return $messages;
}

add_filter('post_updated_messages', 'hr_office_vacancy_post_type_messages' );

//
add_action('admin_menu', 'hr_office_vacancy_license_invalid_remove_menu');
function hr_office_vacancy_license_invalid_remove_menu() {
    global $submenu;    
    $status  = get_option( 'hr_office_vacancy_plugin_license_status' );
    
    if($status != 'valid'){
      unset($submenu['edit.php?post_type=hroffice_vacn_shortc'][10]);
      unset($submenu['edit.php?post_type=hroffice_vacn_shortc'][5]);
    }
    
}

//
add_action( 'admin_init', 'hr_office_vacancy_license_disallowed_admin_pages' );
function hr_office_vacancy_license_disallowed_admin_pages() {
    global $pagenow;
    $status  = get_option( 'hr_office_vacancy_plugin_license_status' );
   
    if(is_admin() && $pagenow == 'edit.php' && $status != 'valid') {
      if(isset( $_GET['post_type'] ) && $_GET['post_type'] == 'hroffice_vacn_shortc' && $_GET['page'] != 'license_configuration'){
        wp_redirect( admin_url( 'edit.php?post_type=hroffice_vacn_shortc&page=license_configuration' ) );
        exit;
      }
    }else if(is_admin() && $pagenow == 'post.php' && $status != 'valid'){
      if(get_post_type( $_GET['post'] ) == 'hroffice_vacn_shortc'){
        wp_redirect( admin_url( 'edit.php?post_type=hroffice_vacn_shortc&page=license_configuration' ) );
        exit;
      } 
    }else if(is_admin() && $pagenow == 'post-new.php' && $status != 'valid'){
      if(isset( $_GET['post_type'] ) && $_GET['post_type'] == 'hroffice_vacn_shortc'){
        wp_redirect( admin_url( 'edit.php?post_type=hroffice_vacn_shortc&page=license_configuration' ) );
        exit;
      }
    }

}